#!/bin/bash
#===============================================================================
#
#          FILE:  cli-color.sh
#
#         USAGE:  ./cli-color.sh
#
#   DESCRIPTION:  Functions for colorizing cli output.
#
#       OPTIONS:  ---
#  REQUIREMENTS:  ---
#          BUGS:  ---
#         NOTES:  Provides function "colorize" and color variables.
#        AUTHOR:  Bill Powell (),
#       COMPANY:
#       VERSION:  1.0
#       CREATED:  07/19/2008 02:12:11 PM EDT
#      REVISION:  ---
#       LICENSE: GPL
#
# Copyright (C) 2008 Bill Powell <bill@billpowellisalive.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#===============================================================================

#Color variables
#Usage:
#echo "${GREEN}Green${NC} is one of my favorite colors."

#Lowercase dark, uppercase light.
red='\e[0;31m'
RED='\e[1;31m'
green='\e[0;32m'
GREEN='\e[1;32m'
yellow='\e[0;33m'
YELLOW='\e[1;33m'
blue='\e[0;34m'
BLUE='\e[1;34m'
magenta='\e[0;35m'
MAGENTA='\e[1;35m'
cyan='\e[0;36m'
CYAN='\e[1;36m'
WHITE='\e[1;39m'
NC='\e[0m'              # No Color

function colorize {

# Usage
# cat file | colorize "highlight me" "${YELLOW}"

	if [ "$3" = "all" ] ; then
		# Colorize whole line.
		sed -e "s/.*$1.*/\\\\\\$2&\\\\\\${NC}/"
	else
		# Colorize only $1
		sed -e "s/\(.*\)\($1\)\(.*\)/\1\\\\\\$2\2\\\\\\${NC}\3/"
	fi
	#Escape sequence might be better: \. Oh well.
}

function echoclr {
# Use echo -e to get color.
while read i
do
	echo -e "$i"
done < $1
}

# Can also use this one liner if you want to pipe in:
#while read i ; do ; echo -e "$i" ; done
alias echoclrpipe='while read i ; do  echo -e "$i" ; done'
